#include "stdio.h"
#include "stdlib.h"
#include "malloc.h"
#include "math.h"
#include "string.h"
#include "time.h"

typedef struct SS {
	int n_var;	
	double digits;
	double *high;
	double *low;
	int **ranges; /* Diversification Generator */
	int PSize;
	int LS;		  /* =1 LocalSearch ON, 0 OFF */
	int iter;

	int b1;
	double **RefSet1;// Solutions 
	double *value1;  // Objective value
	int *order1;	 //	Order of solutions
	int *iter1;		 // Number of iter of each sol.

	int b2;
	double **RefSet2;
	double *value2;	 // Dissim value
	int *order2;
	int *iter2;

	int last_combine;  //Number of iter of last solution combination
	int new_elements;  //True if new elem. added since last combine

	/* Random number parameters */
	long idum;	    				
	int seed_reset;	
	int iff;									
	long ir[98];
	long iy;

} SS;


#define SSgetrandom(p,min,max)  (int)( (SSrandNum(p)*(max+1-min)) + (min))
#define DBL_MAX 	1.7976931348623158e+308 /* max value */


/* File SS_main.c */

double evaluate(SS *prob,double *x);

/* File SS_RefSet.c */

void Initiate_RefSet(SS *prob);
double SSGenerate_value(SS *prob,int a);
void SSimprove_solution(SS *prob, double *sol,double *value);
void Update_RefSet2(SS *prob);
void Combine_RefSet(SS *prob);

/* File SS_Memory.c */

SS *DataStructures_init(int nvar,int b1,int b2,int PSize,int LocalSearch);
void Free_DataStructures(SS *prob);
int **SSallocate_int_matrix(int rows,int columns);
double **SSallocate_double_matrix(int rows,int columns);
double *SSallocate_double_array(int size);
int *SSallocate_int_array(int size);
void SSfree_double_matrix(double **matrix,int rows);
void SSfree_int_matrix(int **matrix,int rows);


/* File SS_tools.c */

float SSrandNum(SS *p);
int *orden_indices(double *pesos,int num,int tipo);
void SSabort(char *texto);
double distance_to_RefSet(SS *prob,double *sol);
double distance_to_RefSet1(SS *prob,double *sol);
int is_new(SS *prob,double **solutions,int dim,double *sol);
void SScombine(SS *prob,double *x,double *y,double **offsprings,int number);
void try_add_RefSet1(SS *prob,double *sol);
void try_add_RefSet2(SS *prob,double *sol);

/* File nmsimplex.c */

int   amoeba(double **p, double *y, int ndim, double ftol, double (*funk)(), int *nfunk,SS *prob);
double amotry(double **p, double *y, double *psum, int ndim, double (*funk)(), int ihi, int *nfunk, double fac,SS *prob);

